# lanparty.tcl v1.o by domsen <domsen@domsen.org> (c)2oo1
#
# comments? bugs? ideas? plz mail me :)
#
# das tcl liest die lanparty.de lannews aus und gibt
# sie wieder, auf wunsch den passenden link und eine msg
# wenn neue newslines auf der page sind.
#
# .lanparty - gibt die 'lanpartylimit' newslines wieder
# .lanpartylink <nr> - gibt den zur nummer passenden 
#                      link wieder
# lanpartylimit "" fr unbegrenzte newsline, ansonsten sollte
#                  ein limit von ca 10 gesetzt werden
# lpnewspost - 1 fr newsposting, 0 fr keines
#
# lanpartychans - die chans in denen das tcl aktiv ist, wobei
#                 "" fr alle steht
#
# alle commands sind pub und per msg verfgbar
#
# man htte dieses tcl auch simpler coden knnen durch den
# gebrauch von regusbs und wget, aber das wre zu einfach
# gewesen da man die regsub-strings aus den php backends
# benutzen knnte - wo bleibt da die herausforderung. wget
# ist auerdem nicht auf allen shells erlaubt, also habe ich
# mich fr lynx entschieden. die tcl http lib wollte ich auch
# nicht benutzen, da ich gerne auf fremden externen code
# vollkommen verzichte :-)
#
####### config ######################

set lptrigger ".lanparty"
set lpsearchtrigger ".lanpartylink"
set lanpartychans ""
set lanpartylimit "10"
set lpnewspost "1"
set islphub "0"
set lpleafs ""


####### ende der config #############

bind msg - $lptrigger msg_lp
bind pub - $lptrigger pub_lp
bind msg - $lpsearchtrigger lpmsg_search
bind pub - $lpsearchtrigger lppub_search
bind time - "?0 * * * *" lpcheck



proc lpcheck { nick uhost hand chan arg } {
global lanpartychans lpnewspost
if {$lpnewspost == 1 } {
set lphdlfile "lanparty.hdl"
set lplastnews "none"
if {[file exists $lphdlfile]} {
putlog "lanparty.de: suche nach neuer newsline"
set temp [open "lanparty.hdl" r]
set counter 0
set hehe " "
while { [eof $temp] != 1 } {
set zeile "[gets $temp]"
if { ([string first "Localize" $zeile] != -1)} {
incr counter }
if { [string first "localize.png" $zeile] != "-1" } {
incr counter }
if {($counter == "1") && ($zeile != "") && ([string first ".gif" $zeile] == "-1") && ([string first "-" $zeile] != "-1") } {
incr counter 
set lplastnews [string range $zeile [expr [string first "]" $zeile] +1 ] [string length $zeile]]
}}
close $temp }
exec lynx -preparsed -dump http://www.lanparty.de/index.phtml?LSession=a706ebf7c28ca8a78b5489812837afbc > lanparty.hdl
set temp [open "lanparty.hdl" r]
set counter 0
set hehe " "
if {$lplastnews == "none" } { 
putlog "lanparty.de: headlinefile created"
return 0 
}
while { [eof $temp] != 1 } {
set zeile "[gets $temp]"
if { ([string first "Localize" $zeile] != -1)} {
incr counter }
if { [string first "localize.png" $zeile] != "-1" } {
incr counter }
if {($counter == "1") && ($zeile != "") && ([string first ".gif" $zeile] == "-1") && ([string first "-" $zeile] != "-1") } {
incr counter 
set lpneunews [string range $zeile [expr [string first "]" $zeile] +1 ] [string length $zeile]]
if {$lplastnews == $lpneunews} { incr counter }
if {$lplastnews != $lpneunews} {
putlog "lanparty.de: neue newsline"
foreach chan [channels] {
if { $lanpartychans == "" } { putserv "privmsg $chan :(neue lanparty.de newsline) $neunews" }
if { $lanpartychans != "" } {
if {([lsearch -exact [string tolower $lanpartychans] [string tolower $chan]] != -1) || ($lanpartychans == "")} {
putserv "privmsg $chan :(neue lanparty newsline) $lpneunews"
}}}}}}
close $temp
}}



proc lpmsg_search { nick uhost hand arg } {
exec lynx -preparsed -dump http://www.lanparty.de/index.phtml?LSession=a706ebf7c28ca8a78b5489812837afbc > lanparty.temp
set temp [open "lanparty.temp" r]
set newslinenr 0
set counter 0
set linknr 0
set checker "duh"
while { [eof $temp] != 1 } {
set zeile "[gets $temp]"
if { ([string first "Localize" $zeile] != -1)} {
incr counter }
if {($counter == "1") && ($zeile != "")  && ([string first ".gif" $zeile] == "-1") && ([string first "-" $zeile] != "-1")} {
incr newslinenr }
if { $arg == $newslinenr } {
set position [string first "]" $zeile]
incr position -2
set linknr "[string range $zeile $position [incr position 1]]. http://www.lanparty.de"
set checker "ok"
}
if {($checker == "ok") && ([string first $linknr $zeile ] != -1)} {
set hyperlink [string range $zeile 6 [string length $zeile]]
putserv "privmsg $nick :$hyperlink"
putlog "lanparty.de: link search by $nick"
set checker "duh"
}}
close $temp
}


proc lppub_search { nick uhost hand chan arg  } {
global lanpartychans
if {([lsearch -exact [string tolower $lanpartychans] [string tolower $chan]] != -1) || ($lanpartychans == "")} {
exec lynx -preparsed -dump http://www.lanparty.de/index.phtml?LSession=a706ebf7c28ca8a78b5489812837afbc > lanparty.temp
set temp [open "lanparty.temp" r]
set newslinenr 0
set counter 0
set linknr 0
set checker "duh"
while { [eof $temp] != 1 } {
set zeile "[gets $temp]"
if { ([string first "Localize" $zeile] != -1)} {
incr counter }
if {($counter == "1") && ($zeile != "")  && ([string first ".gif" $zeile] == "-1") && ([string first "-" $zeile] != "-1")} {
incr newslinenr }
if { $arg == $newslinenr } {
set position [string first "]" $zeile]
incr position -2
set linknr "[string range $zeile $position [incr position 1]]. http://www.lanparty.de"
set checker "ok"
}
if {($checker == "ok") && ([string first $linknr $zeile ] != -1)} {
set hyperlink [string range $zeile 6 [string length $zeile]]
putserv "notice $nick :$hyperlink"
putlog "lanparty.de: link search by $nick on $chan"
set checker "duh"
}}
close $temp
}}












proc msg_lp { nick uhost hand arg } {
global lanpartylimit
exec lynx -preparsed -dump http://www.lanparty.de/index.phtml?LSession=a706ebf7c28ca8a78b5489812837afbc > lanparty.temp
if {($arg == "") && ($lanpartylimit != "")} {
set newslinenr 0
set counter 0
putserv "privmsg $nick :die letzten $lanpartylimit lanparty.de news"
set temp2 [open "lanparty.temp" r]
while { [eof $temp2] != "1" } {
set zeile "[gets $temp2]"
if { [string first "Localize" $zeile] != "-1" } {
incr counter }
if { [string first "localize.png" $zeile] != "-1" } {
incr counter }
if { ($counter == "1") && ($zeile != "") && ([string first ".gif" $zeile] == "-1") && ([string first "-" $zeile] != "-1")} {
set news [string range $zeile 9 [string length $zeile]]
if {$newslinenr < $lanpartylimit } {
incr newslinenr 
putserv "privmsg $nick :$newslinenr $news"
}}}
close $temp2
putlog "lanparty.de: sent last $lanpartylimit newslines to $nick"
return 0 }
if {($arg == "all") || ($lanpartylimit == "")} {
set counter 0
set newslinenr 0
putserv "privmsg $nick :heutige lanparty.de news"
set temp2 [open "lanparty.temp" r]
while { [eof $temp2] != "1" } {
set zeile "[gets $temp2]"
if { [string first "Localize" $zeile] != "-1" } {
incr counter }
if { [string first "localize.png" $zeile] != "-1" } {
incr counter }
if { ($counter == "1") && ($zeile != "") && ([string first ".gif" $zeile] == "-1") && ([string first "-" $zeile] != "-1")} {
set news [string range $zeile 9 [string length $zeile]]
incr newslinenr 
putserv "privmsg $nick :$newslinenr $news"
}}
close $temp2
putlog "lanparty.de: sent all newslines to $nick"
return 0}
}



proc pub_lp { nick uhost hand chan arg } {
global lanpartylimit lanpartychans
if {([lsearch -exact [string tolower $lanpartychans] [string tolower $chan]] != -1) || ($lanpartychans == "")} {
exec lynx -preparsed -dump http://www.lanparty.de/index.phtml?LSession=a706ebf7c28ca8a78b5489812837afbc > lanparty.temp
if {($arg == "") && ($lanpartylimit != "")} {
set newslinenr 0
set counter 0
putserv "notice $nick :die letzten $lanpartylimit lanparty.de news"
set temp2 [open "lanparty.temp" r]
while { [eof $temp2] != "1" } {
set zeile "[gets $temp2]"
if { [string first "Localize" $zeile] != "-1" } {
incr counter }
if { [string first "localize.png" $zeile] != "-1" } {
incr counter }
if { ($counter == "1") && ($zeile != "") && ([string first ".gif" $zeile] == "-1") && ([string first "-" $zeile] != "-1")} {
set news [string range $zeile 9 [string length $zeile]]
if {$newslinenr < $lanpartylimit } {
incr newslinenr 
putserv "notice $nick :$newslinenr $news"
}}}
close $temp2
putlog "lanparty.de: sent last $lanpartylimit newslines to $nick on $chan"
return 0 }
if {($arg == "all") || ($lanpartylimit == "")} {
set counter 0
set newslinenr 0
putserv "notice $nick :heutige lanparty.de news"
set temp2 [open "lanparty.temp" r]
while { [eof $temp2] != "1" } {
set zeile "[gets $temp2]"
if { [string first "Localize" $zeile] != "-1" } {
incr counter }
if { [string first "localize.png" $zeile] != "-1" } {
incr counter }
if { ($counter == "1") && ($zeile != "") && ([string first ".gif" $zeile] == "-1") && ([string first "-" $zeile] != "-1")} {
set news [string range $zeile 9 [string length $zeile]]
incr newslinenr 
putserv "notice $nick :$newslinenr $news"
}}
close $temp2
putlog "lanparty.de: sent all newslines to $nick on $chan"
return 0}
}}

putlog "*** lanparty.tcl v1.o by domsen succesfully loaded"

# [EOF]







